#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
#include <pspctrl.h>
#include <pspaudiolib.h>
#include <pspaudio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

PSP_MODULE_INFO("gameover", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
extern unsigned char spr_start[]; // テクスチャ参照
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
#define CHR_COUNT 256 // スプライト最大数256を指定
#define TXT_COUNT 256 // テキスト最大数も256

// 関数プロトタイプ宣言
void textout(int x,int y,char *ctext);
void MyPlaySE(int iSEnum);
void MyClearSprites();
void MyClearText();
void MyEnding();

// 音声データ参照
extern short bomb_start[];
extern long bomb_size;
extern short shot_start[];
extern long shot_size;
extern short bounce_start[];
extern long bounce_size;
extern short hit_start[];
extern long hit_size;
extern short stagecursor_start[];
extern long stagecursor_size;
extern short gun_start[];
extern long gun_size;
#define SE_SHOT 1
#define SE_HIT 2
#define SE_BOMB 3
#define SE_BOUNCE 4
#define SE_STAGECURSOR 5
#define SE_STAGESELECT 6

// 描画用Vertex構造体
typedef struct Vertex{
	unsigned short u, v;
	unsigned short color;
	short x, y, z;
}Vertex;
struct Vertex* vertices;
struct Vertex* text_vts;

// テクスチャ割り当てをプリプロセッサで定義
#define MY_SHIP 0
#define MY_BOSS 6
#define MY_EFFECT 10
#define MY_BULLET 20
#define MY_ENEMY_BULLET 50

// 敵弾の最大描画数(とりあえず100発まで)
#define MY_ENEMY_BULLET_MAX 100

// グローバル変数定義
unsigned long i=0,j=0;	// 汎用
SceCtrlData pad;		// パッド情報格納用
unsigned long m_ulFrameCount=0; // フレームカウント変数
static int m_iTextCount=0;		// テキストカウント用


// 自機＆バレット用パラメータ定義
unsigned int m_iShip_x,m_iShip_y;
static int m_iBullet_x[11],m_iBullet_y[11],m_iBullet_flag[11];
static int m_iBullet_spd;
// ボス用パラメータ定義。全4ステージを想定してボス4体分
static int m_iStage=0;						// ファミコン選択
static int m_iBoss_x[5]={360,240,400,400};	// ボスX座標
static int m_iBoss_y[5]={104,104,104,200};	// ボスY座標
static int m_iBoss_spd[5]={2,0,8,1};		// ボス移動スピード
static int m_iBoss_hp[5]={100,200,100,400};	// ボスの耐久性
static int m_iBoss_hp_buffer=0;				// 戦う前にボスのHPを待避する
static int m_iBoss_u[5]={  0, 64,128,192};	// ボスのスプライト位置指定用u
static int m_iBoss_v[5]={ 32, 32, 32, 32};	// ボスのスプライト位置指定用v
static int m_iBoss_MoveX=0,m_iBoss_MoveY=0;	// 移動関連パラメータ
// エフェクト用パラメータ定義
static int m_iEffect_x[6],m_iEffect_y[6];	// エフェクト用X座標
static int m_iEffect_time[6];				// エフェクトアニメーション用
static int m_iEffect_addsize=2;				// エフェクト移動量(デフォルト2)
// 敵弾用パラメータ定義。
double m_dEnemyBullt_x[MY_ENEMY_BULLET_MAX+1];				// 敵弾X座標
double m_dEnemyBullt_y[MY_ENEMY_BULLET_MAX+1];				// 敵弾Y座標
static int m_iEnemyBullet_Type[MY_ENEMY_BULLET_MAX+1];		// 敵弾タイプ
double m_dENemyBullet_Spd[MY_ENEMY_BULLET_MAX+1];			// 敵弾スピード
static int m_iEnemyBullet_Num[MY_ENEMY_BULLET_MAX+1];		// 敵弾画像番号
static int m_iEnemyBullet_Hitbox[MY_ENEMY_BULLET_MAX+1];	// 敵弾当たり判定有無(0=スルー)
static int m_iEnemyBullet_Power[MY_ENEMY_BULLET_MAX+1];		// 敵弾耐久値
static int m_iEnemyBullet_Autodec[MY_ENEMY_BULLET_MAX+1];	// 敵弾自動減衰値
double m_dEnemyBullet_bx[MY_ENEMY_BULLET_MAX+1];			// 自機狙い弾などに用いる移動方向X
double m_dEnemyBullet_by[MY_ENEMY_BULLET_MAX+1];			// 自機狙い弾などに用いる移動方向Y
static int m_iEnemyBullet_rfix[MY_ENEMY_BULLET_MAX+1];		// ローリング位置補正用
static int m_iEnemyBullet_Wide[MY_ENEMY_BULLET_MAX+1];		// ローリングバレット幅可変用
static int m_iEnemyBullet_WideBounce[MY_ENEMY_BULLET_MAX+1];// ローリングバレット幅可変の加減算値

// ステージ3ボス専用変数
static int m_iBoss_bounceCount=0,m_iBoss_bounceFlag=0;		// 位置決めやバウンド回数カウント用
double m_dBoss_cos=0,m_dBoss_sin=0;							// 方向決め倍率格納用変数
unsigned long m_ulBoss3FrameCount=0;						// 経過フレームカウント用
// ステージ4ボス専用変数
double m_dBoss4_x=0,m_dBoss4_y=0;							// ボスのX/Y座標

// その他グローバル変数
static int m_iGameoverFlag=0;	// ゲームオーバーフラグ


// 三角関数テーブル
double cos_table[120],sin_table[120];
void MyGenTriTable(){
	for(i=0;i<120;i++){
		cos_table[i] = cos(i*3.14159/60);
		sin_table[i] = sin(i*3.14159/60);
	}
}

// 効果音再生ルーチン
void MyPlaySE(int iSEnumber){
	int pspsample=0;
	static int iUseChannel[8];
	switch(iSEnumber){
		case SE_SHOT: // 自機バレット射出
			sceAudioChRelease(iUseChannel[0]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(shot_size/4);
			iUseChannel[0] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[0],PSP_AUDIO_VOLUME_MAX,shot_start);
			break;
		case SE_HIT: // ボスへの自機バレット衝突
			sceAudioChRelease(iUseChannel[1]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(hit_size/4);
			iUseChannel[1] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[1],PSP_AUDIO_VOLUME_MAX,hit_start);
			break;
		case SE_BOMB: // ボス破壊および敵弾破壊時
			sceAudioChRelease(iUseChannel[2]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(bomb_size/4);
			iUseChannel[2] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[2],PSP_AUDIO_VOLUME_MAX,bomb_start);
			break;
		case SE_BOUNCE: // ステージ3ボスの壁反射時
			sceAudioChRelease(iUseChannel[3]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(bounce_size/4);
			iUseChannel[3] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[3],PSP_AUDIO_VOLUME_MAX,bounce_start);
			break;
		case SE_STAGECURSOR: // ステージセレクトのカーソル音
			sceAudioChRelease(iUseChannel[0]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(stagecursor_size/4);
			iUseChannel[0] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[0],PSP_AUDIO_VOLUME_MAX,stagecursor_start);
			break;
		case SE_STAGESELECT: // ステージ決定の音
			sceAudioChRelease(iUseChannel[0]);
			pspsample = PSP_AUDIO_SAMPLE_ALIGN(gun_size/4);
			iUseChannel[0] = sceAudioChReserve(PSP_AUDIO_NEXT_CHANNEL,pspsample,PSP_AUDIO_FORMAT_STEREO);
			sceAudioOutput(iUseChannel[0],PSP_AUDIO_VOLUME_MAX,gun_start);
			break;
		default:
			break;
	}
}

// 変数初期化自作関数
void MyInitParam(){
	m_iShip_x=32; m_iShip_y=120; // 自機の初期座標を左中央付近へ
	memset(m_iBullet_x,-64,sizeof(m_iBullet_x)); // バレットの位置を(-64,-64)に指定
	memset(m_iBullet_y,-64,sizeof(m_iBullet_y));
	memset(m_iBullet_flag,0,sizeof(m_iBullet_flag)); // 射出フラグは0リセット
	memset(m_iEffect_time,-1,sizeof(m_iEffect_time)); // エフェクトフラグもゼロクリア
	memset(m_dEnemyBullt_x,0,sizeof(m_dEnemyBullt_x)); // 敵弾全座標リセット
	memset(m_dEnemyBullt_y,0,sizeof(m_dEnemyBullt_y)); // 敵弾全座標リセット
	memset(m_iEnemyBullet_Type,-1,sizeof(m_iEnemyBullet_Type)); // 敵弾タイプを全てリセット
	m_iBullet_spd = 8; // 自機バレットの初期速度は8にセット
	m_ulFrameCount = 0; // フレームカウントをゼロに。
}


// gu初期化自作関数
void MyInitGu(){
	sceGuInit(); sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_4444, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x44000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuEnable(GU_TEXTURE_2D);


// テクスチャデータのセット
	sceGuTexMode(GU_PSM_4444, 0, 0, GU_FALSE);
	sceGuTexImage(0, 256, 256, 256, spr_start);
	sceGuTexFunc(GU_TFX_REPLACE, GU_TCC_RGBA);
	sceGuTexFilter(GU_NEAREST, GU_NEAREST);
	// 透過ルーチン
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0); 

	// 設定完了
	sceGuFinish(); sceGuSync(0, GU_SYNC_FINISH);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	// ディスプレイリストからメモリ割り当て(CHR_COUNT利用)
	vertices = (struct Vertex*)sceGuGetMemory(2*CHR_COUNT* sizeof(struct Vertex));
	// さらにテキスト用も割り当て
	text_vts = (struct Vertex*)sceGuGetMemory(2*TXT_COUNT* sizeof(struct Vertex));
}

// 自機パラメータ制御 vertices[0-1]利用
void MyShip(){
	static int iMyShipAnime=0; // 8フレームに一度ブリンクさせる変数
	// 上下左右操作はMyShipで処理
	if((pad.Buttons & PSP_CTRL_UP   ) && m_iShip_y>0  ) m_iShip_y-=4;
	if((pad.Buttons & PSP_CTRL_DOWN ) && m_iShip_y<256) m_iShip_y+=4;
	if((pad.Buttons & PSP_CTRL_LEFT ) && m_iShip_x>0  ) m_iShip_x-=4;
	if((pad.Buttons & PSP_CTRL_RIGHT) && m_iShip_x<448) m_iShip_x+=4;
	// テクスチャの割り当てやアニメーションを定義
	vertices[MY_SHIP  ].x = m_iShip_x;
	vertices[MY_SHIP+1].x = m_iShip_x+32;
	vertices[MY_SHIP  ].y = m_iShip_y;
	vertices[MY_SHIP+1].y = m_iShip_y+16;
	iMyShipAnime++;
	if(iMyShipAnime%8==0){
		vertices[MY_SHIP  ].u = 0;	vertices[MY_SHIP  ].v = 0;
		vertices[MY_SHIP+1].u = 32;	vertices[MY_SHIP+1].v = 16;
	}else{
		vertices[MY_SHIP  ].u = 32;	vertices[MY_SHIP  ].v = 0;
		vertices[MY_SHIP+1].u = 64;	vertices[MY_SHIP+1].v = 16;
	}
}
// 自機バレット制御関数コール
void MyBullet(){
	static int iBulletNextWait=0;
	// Xキーを押した場合は射出ルーチンを処理(ゲームオーバー中は不可)
	if((pad.Buttons & PSP_CTRL_CROSS) && iBulletNextWait==0 && m_iGameoverFlag==0){
		// 空きバレットを走査し、空きがあれば目の前に設置
		for(i=0;i<=9;i++) if(m_iBullet_flag[i]==0) break;
		if(i!=10){
			MyPlaySE(SE_SHOT); // ショット時に効果音を鳴らす
			m_iBullet_flag[i]=1; // バレットを使用中に
			m_iBullet_x[i] = m_iShip_x + 20;
			m_iBullet_y[i] = m_iShip_y;
			iBulletNextWait = 4; // 4フレームのウェイトを入れる
		}
	}
	if(iBulletNextWait!=0) iBulletNextWait--;
	for(i=0;i<=9;i++){
		if(m_iBullet_flag[i]==1){ // 画面に存在している場合は
			m_iBullet_x[i]+=m_iBullet_spd; // 弾速分を加算
			vertices[MY_BULLET+i*2  ].x = m_iBullet_x[i];
			vertices[MY_BULLET+i*2+1].x = m_iBullet_x[i]+16;
			vertices[MY_BULLET+i*2  ].y = m_iBullet_y[i];
			vertices[MY_BULLET+i*2+1].y = m_iBullet_y[i]+16;
			vertices[MY_BULLET+i*2  ].u = 64;
			vertices[MY_BULLET+i*2+1].u = 80;
			vertices[MY_BULLET+i*2  ].v = 0;
			vertices[MY_BULLET+i*2+1].v = 16;
			// 存在している場合のみボスとの当たり判定を求める
			if(m_iBullet_x[i]>=m_iBoss_x[m_iStage] && m_iBullet_x[i]<=m_iBoss_x[m_iStage]+60 &&
			   m_iBullet_y[i]+12>=m_iBoss_y[m_iStage] && m_iBullet_y[i]<=m_iBoss_y[m_iStage]+60){
				// エフェクト0-5を走査して空きにセット
				for(j=0;j<=4;j++){
					if(m_iEffect_time[j]<0){
						m_iEffect_x[j] = m_iBullet_x[i];
						m_iEffect_y[j] = m_iBullet_y[i];
						m_iEffect_time[j] = 31; // アニメーションフレームセット
						break; // 空きを発見したらループ脱出
					}
				}
				m_iBullet_x[i]=512; // 衝突した場合は画面外までバレットを飛ばす
				m_iBoss_hp[m_iStage]--; // ボスの耐久値をマイナス1
				MyPlaySE(SE_HIT); // ボス衝突時に効果音を鳴らす
			}
		}
		// 画面外に消えたら空きバレットに降格
		if(m_iBullet_x[i]>512) m_iBullet_flag[i]=0;
	}
}

// ボスの射出する敵弾関連ルーチン
// 書式 MyGenerateEnemyBullet(座標X,座標Y,タイプ,移動速度,敵弾画像,当たり判定,耐久値,自動減衰値)
void MyGenerateEnemyBullet(double x,double y,int type,double spd,int num,int hitbox,int power,int autodec){
	double dRad,dKaku; // 角度用
	// 空きを走査する
	for(i=0;i<MY_ENEMY_BULLET_MAX;i++) if(m_iEnemyBullet_Type[i]==-1) break;
	// 空きスロットに敵弾ステータスをセット
	m_dEnemyBullt_x[i] = x;
	m_dEnemyBullt_y[i] = y;
	m_iEnemyBullet_Type[i] = type;
	m_dENemyBullet_Spd[i] = spd;
	m_iEnemyBullet_Num[i] = num;
	m_iEnemyBullet_Hitbox[i] = hitbox;
	m_iEnemyBullet_Power[i] = power;
	m_iEnemyBullet_Autodec[i] = autodec;
	// 自機狙い弾などのために移動方向初期値をセット
	switch(type){
		default:
		case 0:
		case 1:break;
		case 2: // 自機狙い弾
			dRad=atan2((m_iShip_y+8)-(y+8) , (m_iShip_x+16)-(x+8));
			m_dEnemyBullet_bx[i] = cos(dRad) * spd;
			m_dEnemyBullet_by[i] = sin(dRad) * spd;
			break;
		case 3: // うずまき弾幕
			dKaku = m_ulFrameCount%60; // フレームカウントから角度を生成
			m_dEnemyBullet_bx[i] = cos(dKaku*3.14159/30) * spd;
			m_dEnemyBullet_by[i] = sin(dKaku*3.14159/30) * spd;
			break;
		case 4: // ランダム弾幕
			dKaku = rand()%360; // ランダム角度を生成
			m_dEnemyBullet_bx[i] = cos(dKaku*3.14159/180) * spd;
			m_dEnemyBullet_by[i] = sin(dKaku*3.14159/180) * spd;
			break;
		case 5: // 時計回りローリングシールド。Xを間隔ずらしRFIX用に割り当て
			m_iEnemyBullet_rfix[i] = (int)x;
			break;
		case 6: // 反時計回りローリングバレット。Xを間隔ずらしRFIX用に割り当て
			m_iEnemyBullet_rfix[i] = (int)x;
			m_iEnemyBullet_Wide[i] = 0; // 可変幅初期化
			m_iEnemyBullet_WideBounce[i] = 1; // 可変値初期化
			break;
		case 7: // 画面内バウンド弾幕(エンディング専用。
			dKaku = rand()%360; // ランダム角度を生成(ベースはランダム弾と同じ)
			m_dEnemyBullet_bx[i] = cos(dKaku*3.14159/180) * spd;
			m_dEnemyBullet_by[i] = sin(dKaku*3.14159/180) * spd;
			break;
	}
}
void MyEnemyBullet(){
	for(i=0;i<MY_ENEMY_BULLET_MAX;i++){
		if(m_iEnemyBullet_Type[i]==-1) continue; // 無駄弾スキップ
		// 敵弾タイプに応じて軌道を変える
		switch(m_iEnemyBullet_Type[i]){
			default:
			case 0:
				break;
			case 1:
				m_dEnemyBullt_x[i]-=m_dENemyBullet_Spd[i];
				break;
			case 2: // 自機狙い弾と
			case 3: // うずまき段幕と
			case 4: // ランダム段幕は同じ式
				m_dEnemyBullt_x[i] += m_dEnemyBullet_bx[i];
				m_dEnemyBullt_y[i] += m_dEnemyBullet_by[i];
				break;
			case 5: // 時計りの固定幅回転を描画
				m_dEnemyBullt_x[i] = m_iBoss_x[m_iStage] + 24 +
					(int)(cos_table[(m_ulFrameCount+m_iEnemyBullet_rfix[i])%120]*m_dENemyBullet_Spd[i]);
				m_dEnemyBullt_y[i] = m_iBoss_y[m_iStage] + 24 +
					(int)(sin_table[(m_ulFrameCount+m_iEnemyBullet_rfix[i])%120]*m_dENemyBullet_Spd[i]);
				break;
			case 6: // 反時計りの可変幅回転を描画
				m_dEnemyBullt_x[i] = m_iBoss_x[m_iStage] + 24 +
					(int)(cos_table[119-((m_ulFrameCount+m_iEnemyBullet_rfix[i])%120)]*
					(m_iEnemyBullet_Wide[i] + m_dENemyBullet_Spd[i]));
				m_dEnemyBullt_y[i] = m_iBoss_y[m_iStage] + 24 +
					(int)(sin_table[119-((m_ulFrameCount+m_iEnemyBullet_rfix[i])%120)]*
					(m_iEnemyBullet_Wide[i] + m_dENemyBullet_Spd[i]));
				// 可変幅を増減させる
				m_iEnemyBullet_Wide[i] += m_iEnemyBullet_WideBounce[i];
				if(m_iEnemyBullet_Wide[i]<0 || m_iEnemyBullet_Wide[i]>48)
					m_iEnemyBullet_WideBounce[i] = -m_iEnemyBullet_WideBounce[i];
				break;
			case 7: // 画面内バウンド弾(ランダム弾をベースに反転処理を含める
				m_dEnemyBullt_x[i] += m_dEnemyBullet_bx[i];
				m_dEnemyBullt_y[i] += m_dEnemyBullet_by[i];
				if(m_dEnemyBullt_x[i]<0 || m_dEnemyBullt_x[i]>464)
					m_dEnemyBullet_bx[i]=-m_dEnemyBullet_bx[i];
				if(m_dEnemyBullt_y[i]<0 || m_dEnemyBullt_y[i]>256)
					m_dEnemyBullet_by[i]=-m_dEnemyBullet_by[i];				
				break;

		}
		// 自機の当たり判定を処理
		if((m_iEnemyBullet_Hitbox[i] & 0x01) && m_iShip_x+16>(int)m_dEnemyBullt_x[i] && m_iShip_x+16<(int)m_dEnemyBullt_x[i]+16
		 && m_iShip_y+8>(int)m_dEnemyBullt_y[i] && m_iShip_y+8<(int)m_dEnemyBullt_y[i]+16){
			m_iGameoverFlag = 1; // ゲームオーバーフラグを立てる
			return;
		}
		// 自機バレットの当たり判定を処理
		for(j=0;j<=9;j++){
			if(m_iBullet_flag[j]==0) continue; // 未射出バレットは処理しない
			if((m_iEnemyBullet_Hitbox[i] & 0x02) && m_iBullet_x[j]+8>(int)m_dEnemyBullt_x[i] && m_iBullet_x[j]+8<(int)m_dEnemyBullt_x[i]+16
			 && m_iBullet_y[j]+8>(int)m_dEnemyBullt_y[i] && m_iBullet_y[j]+8<(int)m_dEnemyBullt_y[i]+16){
				m_iEnemyBullet_Power[i]--; // 敵弾の耐久度を-1する
				m_iBullet_x[j]=512; // 画面外まで自機バレットを移動させて消去
			}
		}
		// 自動減衰処理も行う
		m_iEnemyBullet_Power[i] -= m_iEnemyBullet_Autodec[i];
		// 敵弾の耐久性が0未満になったらタイプ-1に戻す
		if(m_iEnemyBullet_Power[i]<0){
			m_iEnemyBullet_Type[i]=-1;
			// エフェクト0-5を走査して空きにセット
			for(j=0;j<=4;j++){
				if(m_iEffect_time[j]<0){
					m_iEffect_x[j] = (int)m_dEnemyBullt_x[i];
					m_iEffect_y[j] = (int)m_dEnemyBullt_y[i];
					m_iEffect_time[j] = 31; // アニメーションフレームセット
					break; // 空きを発見したらループ脱出
				}
			}
		}

		// 弾が画面外に出たらタイプを-1に戻す
		if(m_dEnemyBullt_x[i]<-32 || m_dEnemyBullt_x[i]>512 ||
		 m_dEnemyBullt_y[i]<-32 || m_dEnemyBullt_y[i]>320){
			// タイプ5と6は画面外に出ても消さない
			if(m_iEnemyBullet_Type[i]!=5 && m_iEnemyBullet_Type[i]!=6){
				m_iEnemyBullet_Type[i]=-1;
			}
		}
		// スプライト値をセット
		vertices[MY_ENEMY_BULLET+i*2  ].x = (int)m_dEnemyBullt_x[i];
		vertices[MY_ENEMY_BULLET+i*2+1].x = (int)m_dEnemyBullt_x[i]+16;
		vertices[MY_ENEMY_BULLET+i*2  ].y = (int)m_dEnemyBullt_y[i];
		vertices[MY_ENEMY_BULLET+i*2+1].y = (int)m_dEnemyBullt_y[i]+16;
		vertices[MY_ENEMY_BULLET+i*2  ].u = 64 + m_iEnemyBullet_Num[i]*16;
		vertices[MY_ENEMY_BULLET+i*2+1].u = 80 + m_iEnemyBullet_Num[i]*16;
		vertices[MY_ENEMY_BULLET+i*2  ].v = 16;
		vertices[MY_ENEMY_BULLET+i*2+1].v = 32;
	}
}

// ボス制御ルーチン一式
void MyInitBoss(){
	switch(m_iStage){
		default:
		case 0: // ステージ1の初期値
			m_iBoss_MoveY = m_iBoss_spd[m_iStage];
			break;
		case 3: // ステージ4の初期値
			m_dBoss4_x = (double)m_iBoss_x[m_iStage];
			m_dBoss4_y = (double)m_iBoss_y[m_iStage];
			// 時計回りローリングシールド定義
			for(i=0;i<5;i++){
				// 補正i*24、type5、倍率48、敵弾2(青)、判定2(自機バレット)、耐久MAX、減衰0
				MyGenerateEnemyBullet(i*24,0,5,48,2,2,32767,0);
			}
			// 反時計回りローリングバレット定義
			for(i=5;i<10;i++){
				// 補正i*24、type5、倍率32、敵弾3(赤)、判定1(自機バレット)、耐久MAX、減衰0
				MyGenerateEnemyBullet(i*24,0,6,32,3,1,32767,0);
			}
			// 反時計回りローリングバレット2本目
			for(i=10;i<15;i++){
				// 補正i*24、type5、倍率32、敵弾3(赤)、判定1(自機バレット)、耐久MAX、減衰0
				MyGenerateEnemyBullet(i*24,0,6,48,3,1,32767,0);
			}
			// 反時計回りローリングバレット3本目
			for(i=15;i<20;i++){
				// 補正i*24、type5、倍率32、敵弾3(赤)、判定1(自機バレット)、耐久MAX、減衰0
				MyGenerateEnemyBullet(i*24,0,6,64,3,1,32767,0);
			}
			break;
	}
}

void MyBoss(){
	double dRad=0; // ラジアン格納用
	// ステージ個別にパラメータ参照
	vertices[MY_BOSS  ].x = m_iBoss_x[m_iStage];
	vertices[MY_BOSS+1].x = m_iBoss_x[m_iStage] + 64;
	vertices[MY_BOSS  ].y = m_iBoss_y[m_iStage];
	vertices[MY_BOSS+1].y = m_iBoss_y[m_iStage] + 64;
	vertices[MY_BOSS  ].u = m_iBoss_u[m_iStage];
	vertices[MY_BOSS+1].u = m_iBoss_u[m_iStage] + 64;
	vertices[MY_BOSS  ].v = m_iBoss_v[m_iStage];
	vertices[MY_BOSS+1].v = m_iBoss_v[m_iStage] + 64;
	switch(m_iStage){
		default:
		case 0: // ステージ1
			m_iBoss_y[m_iStage] += m_iBoss_MoveY;
			// 画面端で反転
			if(m_iBoss_y[m_iStage]< 0 || m_iBoss_y[m_iStage]>208) m_iBoss_MoveY = -m_iBoss_MoveY;
			// 30フレーム間隔で交互に電源ボタンと開閉ボタンから敵弾を射出
			if(m_ulFrameCount%60==0)
				MyGenerateEnemyBullet(m_iBoss_x[m_iStage],m_iBoss_y[m_iStage]+4 ,1,4.0f,0,1,1,0);
			if((30+m_ulFrameCount)%60==0)
				MyGenerateEnemyBullet(m_iBoss_x[m_iStage],m_iBoss_y[m_iStage]+44,1,4.0f,0,1,1,0);
			break;
		case 1: // ステージ2
			// 自機狙い＆うずまき＆ランダム拡散弾
			if(m_ulFrameCount%7==0){
				MyGenerateEnemyBullet(m_iBoss_x[m_iStage]+24,m_iBoss_y[m_iStage]+24 ,3,0.5f,0,1,1,0);
				MyGenerateEnemyBullet(m_iBoss_x[m_iStage]+24,m_iBoss_y[m_iStage]+24 ,4,4.0f,0,1,1,0);
			}
			if(m_ulFrameCount%60==0)
				MyGenerateEnemyBullet(m_iBoss_x[m_iStage]+24,m_iBoss_y[m_iStage]+24 ,2,4.0f,0,1,1,0);
			break;
		case 2: // ステージ3
			// 壁にぶつかった回数ゼロ回＆180フレーム後に自機方向を定める
			if(m_iBoss_bounceFlag==0){
				if(m_ulFrameCount - m_ulBoss3FrameCount>180){
					dRad=atan2(((double)m_iShip_y+8)-((double)m_iBoss_y[m_iStage]+32) ,
								 ((double)m_iShip_x+16)-((double)m_iBoss_x[m_iStage]+32));
					m_dBoss_cos = cos(dRad) * m_iBoss_spd[m_iStage];
					m_dBoss_sin = sin(dRad) * m_iBoss_spd[m_iStage];
					m_iBoss_bounceFlag=1; // フラグを立てて次回まで方向は決めないようにする
				}else{ // 停止中に高速自機狙い弾を乱射
					if(m_ulFrameCount%10==0)
						MyGenerateEnemyBullet(m_iBoss_x[m_iStage]+24,m_iBoss_y[m_iStage]+24 ,2,8.0f,0,1,1,0);					
				}
			}
			// 壁にぶつかる都度に回数をカウントし、移動方向を反転
			if(m_iBoss_bounceFlag==1 && m_iBoss_x[m_iStage]<0){
				m_iBoss_x[m_iStage]=0;
				m_dBoss_cos=-m_dBoss_cos; m_iBoss_bounceCount++;
				MyPlaySE(SE_BOUNCE); // 壁衝突時の効果音
			}
			if(m_iBoss_bounceFlag==1 && m_iBoss_x[m_iStage]>424){
				m_iBoss_x[m_iStage]=416;
				m_dBoss_cos=-m_dBoss_cos; m_iBoss_bounceCount++;
				MyPlaySE(SE_BOUNCE); // 壁衝突時の効果音
			}
			if(m_iBoss_bounceFlag==1 && m_iBoss_y[m_iStage]<-8){
				m_iBoss_y[m_iStage]=-8;
				m_dBoss_sin=-m_dBoss_sin; m_iBoss_bounceCount++;
				MyPlaySE(SE_BOUNCE); // 壁衝突時の効果音
			}
			if(m_iBoss_bounceFlag==1 && m_iBoss_y[m_iStage]>216){
				m_iBoss_y[m_iStage]=216;
				m_dBoss_sin=-m_dBoss_sin; m_iBoss_bounceCount++;
				MyPlaySE(SE_BOUNCE); // 壁衝突時の効果音
			}
			// 壁に3回ぶつかったらカウントとフラグをゼロクリアし基準フレームを更新
			if(m_iBoss_bounceCount>=3 && m_iBoss_bounceFlag==1){
				m_iBoss_bounceCount=0; m_iBoss_bounceFlag=0;
				m_dBoss_cos=0; m_dBoss_sin=0;
				m_ulBoss3FrameCount = m_ulFrameCount;
			}
			// ボスの座標を加算
			m_iBoss_x[m_iStage] += (int)m_dBoss_cos;
			m_iBoss_y[m_iStage] += (int)m_dBoss_sin;
			break;
		case 3: // ステージ4
			// 5フレームに一度軌道修正
			if(m_ulFrameCount%5==0){
				dRad=atan2(((double)m_iShip_y+8)-(m_dBoss4_y+32) ,
							 ((double)m_iShip_x+16)-(m_dBoss4_x+32));
				m_dBoss_cos = cos(dRad) * m_iBoss_spd[m_iStage];
				m_dBoss_sin = sin(dRad) * m_iBoss_spd[m_iStage];

			}
			// ボスの座標を加算
			m_dBoss4_x += m_dBoss_cos; m_iBoss_x[m_iStage] = (int)m_dBoss4_x;
			m_dBoss4_y += m_dBoss_sin; m_iBoss_y[m_iStage] = (int)m_dBoss4_y;
			break;
	}
}

// エフェクト制御ルーチン
void MyEffect(){
	for(i=0;i<=4;i++){
		if(m_iEffect_time[i]<0){ // フラグ0以下のときは画面外に
			m_iEffect_x[i] = 512;
			vertices[MY_EFFECT+i*2  ].x = m_iEffect_x[i];
			vertices[MY_EFFECT+i*2+1].x = m_iEffect_x[i]+16;
		}else{ // アニメーションフレームが-1以外の場合は描画
			vertices[MY_EFFECT+i*2  ].x = m_iEffect_x[i];
			vertices[MY_EFFECT+i*2+1].x = m_iEffect_x[i]+16;
			vertices[MY_EFFECT+i*2  ].y = m_iEffect_y[i];
			vertices[MY_EFFECT+i*2+1].y = m_iEffect_y[i]+16;
			vertices[MY_EFFECT+i*2  ].u = 48 - ((m_iEffect_time[i] / 8) *16);
			vertices[MY_EFFECT+i*2+1].u = 64 - ((m_iEffect_time[i] / 8) *16);
			vertices[MY_EFFECT+i*2  ].v = 16;
			vertices[MY_EFFECT+i*2+1].v = 32;
			m_iEffect_time[i]-=2; // フレームを2ずつ減らす
			m_iEffect_x[i]+=m_iEffect_addsize; // 衝突位置から爆風が反動で前進
		}
	}
}

// テキスト描画ルーチン
void textout(int x,int y,char *ctext){
	int i=0;
	char cChar=0;
	for(i=0;i<strlen(ctext);i++){
		cChar = ctext[i] - ' '; // スペース=0にセット
		text_vts[m_iTextCount*2  ].x = (i*16)+x;
		text_vts[m_iTextCount*2+1].x = (i*16)+x+16;
		text_vts[m_iTextCount*2  ].y = y;
		text_vts[m_iTextCount*2+1].y = y+16;
		text_vts[m_iTextCount*2  ].u = ((cChar%16)*16);
		text_vts[m_iTextCount*2+1].u = ((cChar%16)*16)+16;
		text_vts[m_iTextCount*2  ].v = 192+((cChar/16)*16);
		text_vts[m_iTextCount*2+1].v = 208+((cChar/16)*16);
		m_iTextCount++;
	}
}
// textout()を一通り設置し終わったらループ末端で下記コードを入れる。
void textoutFinish(){
	sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, TXT_COUNT*2, 0, text_vts);
	m_iTextCount=0; // 描画命令を実行した後はテキスト総数をゼロにリセット
}

// ステージセレクトルーチン
void MyStageSelect(){
	int iKeyStop=1;
	while(1){
		sceCtrlReadBufferPositive(&pad, 1);
		sceGuStart(GU_DIRECT,list); sceGuClear(GU_COLOR_BUFFER_BIT);
		// ボス4体を描画
		for(i=0;i<4;i++){
			if(m_iBoss_hp[i]<=0) continue; // 倒したボスは非表示
			vertices[i*2  ].x = i*100 + 60;
			vertices[i*2+1].x = i*100 + 60 + 64;
			vertices[i*2  ].y = 100;
			vertices[i*2+1].y = 100 + 64;
			vertices[i*2  ].u = i*64;
			vertices[i*2+1].u = i*64 + 64;
			vertices[i*2  ].v = 32;
			vertices[i*2+1].v = 32 + 64;
		}

		// テキスト描画（カーソル含む）
		textout(112,32,"- STAGE SELECT -");
		textout(m_iStage*100+60,80 ,"====");
		textout(m_iStage*100+60,166,"====");
		// 描画終端処理
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		textoutFinish();
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
		// 左右でカーソル移動。○キー入力でループ脱出
		if((pad.Buttons & PSP_CTRL_LEFT) && iKeyStop==0){
			if(m_iStage==0) m_iStage=3; else m_iStage--;
			iKeyStop=1; MyPlaySE(SE_STAGECURSOR); // キー重複防止と効果音再生
		}
		if((pad.Buttons & PSP_CTRL_RIGHT) && iKeyStop==0){
			if(m_iStage==3) m_iStage=0; else m_iStage++;
			iKeyStop=1; MyPlaySE(SE_STAGECURSOR); // キー重複防止と効果音再生
		}
		if(m_iBoss_hp[m_iStage]>0 && ((pad.Buttons & PSP_CTRL_CIRCLE))){
			break;
		}
		if(!pad.Buttons) iKeyStop=0;
	}
	MyPlaySE(SE_STAGESELECT); // 選択した瞬間に効果音を鳴らす
	// 描画したボスおよびテキスト情報をクリア
	MyClearSprites(); MyClearText();
	// READYを表示(60フレーム)
	for(i=0;i<60;i++){
		sceGuStart(GU_DIRECT,list); sceGuClear(GU_COLOR_BUFFER_BIT);
		textout(200,100,"READY..");
		textoutFinish();
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	// テキストのみクリア
	MyClearText();
}

// 全スプライトリセット
void MyClearSprites(){
	int a=0;
	for(a=0;a<CHR_COUNT;a++){
		vertices[a].x=0; vertices[a].y=0; vertices[a].u=0; vertices[a].v=0;
	}
}
// 全テキストリセット
void MyClearText(){
	int a=0;
	for(a=0;a<TXT_COUNT;a++){
		text_vts[a].x=0; text_vts[a].y=0; text_vts[a].u=0; text_vts[a].v=0;
	}
}

// ステージクリア
void MyStageClear(){
	char temp[256];
	MyClearSprites(); // 一旦スプライトを全クリアしてバレットなどを消去。
	// クリア後の死亡を防ぐため＆ボス爆発エフェクトのため敵バレットを全消失させる
	for(i=0;i<MY_ENEMY_BULLET_MAX;i++) m_iEnemyBullet_Type[i]=-1;
	while(1){
		sceCtrlReadBufferPositive(&pad, 1); // パッド情報セット
		sceGuStart(GU_DIRECT,list); sceGuClear(GU_COLOR_BUFFER_BIT);
		// ボスのスプライトはその場に描画
		vertices[MY_BOSS  ].x = m_iBoss_x[m_iStage];
		vertices[MY_BOSS+1].x = m_iBoss_x[m_iStage] + 64;
		vertices[MY_BOSS  ].y = m_iBoss_y[m_iStage];
		vertices[MY_BOSS+1].y = m_iBoss_y[m_iStage] + 64;
		vertices[MY_BOSS  ].u = m_iBoss_u[m_iStage];
		vertices[MY_BOSS+1].u = m_iBoss_u[m_iStage] + 64;
		vertices[MY_BOSS  ].v = m_iBoss_v[m_iStage];
		vertices[MY_BOSS+1].v = m_iBoss_v[m_iStage] + 64;
		// その上にランダムで爆風を描画。耐久時間2の敵弾をランダム配置で実装
		MyGenerateEnemyBullet(m_iBoss_x[m_iStage] -16 + rand()%64,m_iBoss_y[m_iStage] -16 + rand()%80,1,0,4,0,2,1);
		MyEnemyBullet();
		// 5フレームに一度爆音を鳴らす
		m_ulFrameCount++; if(m_ulFrameCount%5==0) MyPlaySE(SE_BOMB);
		// クリアメッセージを表示
		sprintf(temp,"STAGE %d CLEAR",m_iStage+1);
		textout(240,240,temp);

		// ステージクリア描画中も自機操作できるように
		MyShip();	// 自機制御関数コール
		MyBullet();	// 自機バレット制御関数コール
		MyEffect(); // エフェクト制御関数コール
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		textoutFinish(); sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
		if(pad.Buttons & PSP_CTRL_START) break; // スタートでループ脱出
	}
	// ループ脱出後にもテキストやスプライトをクリアする
	MyClearSprites(); MyClearText(); 
}

// ゲームオーバー
void MyGameOver(){
	char temp[256];
	m_iEffect_addsize=0;
	while(1){
		sceCtrlReadBufferPositive(&pad, 1); // パッド情報セット
		sceGuStart(GU_DIRECT,list); sceGuClear(GU_COLOR_BUFFER_BIT);
		MyGenerateEnemyBullet(m_iShip_x -8+ rand()%24,m_iShip_y -8+ rand()%16,1,0,4,0,2,1);
		MyBullet(); MyBoss(); MyEffect(); MyEnemyBullet();
		sprintf(temp,"GAME OVER"); textout(280,240,temp);
		// 5フレームに一度爆音を鳴らす
		m_ulFrameCount++; if(m_ulFrameCount%5==0) MyPlaySE(SE_BOMB);
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		textoutFinish(); sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
		if(pad.Buttons & PSP_CTRL_START) break; // スタートでループ脱出
	}
	// ループ脱出後にもテキストやスプライトをクリア。
	// ゲームオーバーフラグを解除しエフェクト移動量も戻す
	MyClearSprites(); MyClearText(); m_iGameoverFlag=0; m_iEffect_addsize=2;
}

// エンディング
void MyEnding(){
	char temp[256];
	int iEndingFlag=1;
	// ボスを全て倒しているかチェック
	for(i=0;i<=3;i++){
		if(m_iBoss_hp[i]>0) iEndingFlag=0;
	}
	if(iEndingFlag==0) return;
	// エンディング開始
	while(1){
		sceGuStart(GU_DIRECT,list); sceGuClear(GU_COLOR_BUFFER_BIT);
		// ローリングをランダム表示
		m_ulFrameCount++;
		if(m_ulFrameCount%10==0){
			MyGenerateEnemyBullet(rand()%460,rand()%240,7,rand()%8+1,rand()%2+2,0,rand()%100,0);
		}
		MyEnemyBullet();
		// エンディングメッセージ表示
		sprintf(temp,"MISSION ALL OVER");
		textout(120,120,temp);
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		textoutFinish(); sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
}


// メインルーチン
int main() {
	MyInitGu();		// gu初期化コール
	// ループの都合上パッド初期化と三角関数テーブル初期化のみここへ
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	MyGenTriTable();
LOOP:
	MyInitParam();	// 変数初期化コール
	MyEnding();		// ステージセレクト前にエンディング判定とエンディング。
	MyStageSelect(); // ステージセレクト関数コール
	MyInitBoss();	// ボス初期化コール(暫定)。最終的にはステージセレクト後に呼び出す予定。
	m_iBoss_hp_buffer = m_iBoss_hp[m_iStage]; // ボスのHPを控える(ゲームオーバー用)
	while(1){
		sceCtrlReadBufferPositive(&pad, 1); // パッド情報セット
		sceGuStart(GU_DIRECT,list);
		sceGuClear(GU_COLOR_BUFFER_BIT); // 毎回描画クリア
		MyShip();	// 自機制御関数コール
		MyBullet();	// 自機バレット制御関数コール
		MyBoss();	// ボス制御関数コール
		MyEffect(); // エフェクト制御関数コール
		MyEnemyBullet(); // 敵弾処理関数コール
		m_ulFrameCount++; // フレームカウント変数インクリメント

		// テキストアウトテスト
		char temp[256];
		sprintf(temp,"%d ",m_iBoss_hp[m_iStage]);
		textout(0,0,temp);

		// ループ末尾で描画処理を実行
		sceGuDrawArray(GU_SPRITES,GU_TEXTURE_16BIT|GU_COLOR_4444|GU_VERTEX_16BIT|GU_TRANSFORM_2D, CHR_COUNT*2, 0, vertices);
		// テキストアウトを最後に実行することで最前面に表示している。
		textoutFinish();
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
		// ボスのHPがゼロであればステージクリアルーチンへ
		if(m_iBoss_hp[m_iStage]<=0){
			MyStageClear();
			goto LOOP;
		}
		// 自機ゲームオーバーフラグが立っていればゲームオーバーへ
		if(m_iGameoverFlag!=0){
			MyGameOver();
			m_iBoss_hp[m_iStage] = m_iBoss_hp_buffer;
			goto LOOP;
		}
	}
	return 0;
}
